SystemOrganization addCategory: #'Seaside-REST-Core-Handler'!
SystemOrganization addCategory: #'Seaside-REST-Core-Route'!

!GRPackage class methodsFor: '*seaside-rest-core' stamp: 'pmm 8/8/2010 11:15'!
seasideRestCore
	^ self new
		name: 'Seaside-REST-Core';
		description: 'Write RESTful web services using Seaside';
		addDependency: 'Seaside-Core';
		url: #seasideAddonsUrl;
		yourself! !

!GRPlatform methodsFor: '*seaside-rest-core' stamp: 'lr 7/26/2011 14:17'!
argumentNamesOf: aCompiledMethod
	"Answer the argument names of a method as a sequenceable collection of strings. The default implementation does not support this call."

	^ #()! !

!GRPlatform methodsFor: '*seaside-rest-core' stamp: 'pmm 8/27/2011 09:53'!
createRoutesFor: aClass
	^ WARouteBuilder createRoutesFor: aClass! !

!GRPlatform methodsFor: '*seaside-rest-core' stamp: 'pmm 8/27/2011 09:53'!
createRoutesFrom: aClass to: aSuperClass
	^ WARouteBuilder createRoutesFrom: aClass to: aSuperClass! !

WARequestFilter subclass: #WARestfulFilter
	instanceVariableNames: 'routes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Handler'!

!WARestfulFilter methodsFor: 'private' stamp: 'pmm 8/27/2011 09:55'!
createRoutes
	"Creates a collection of routes for the receiver. Override this method in subclasses to explicitely create the routes instead of using the default implementation that builds the routes using annotated methods (pragmas)."

	^ GRPlatform current createRoutesFrom: self class to: WARestfulFilter! !

!WARestfulFilter methodsFor: 'handling' stamp: 'pmm 2/19/2012 09:42'!
executeResult: aRouteResult
	self requestContext respond: [ :response |
		| mimeType |
		mimeType := aRouteResult seasideMimeType.
		mimeType isNil
			ifTrue: [
				response
					document: (aRouteResult sendMessageTo: self) ]
			ifFalse: [
				response
					document: (aRouteResult sendMessageTo: self)
					mimeType: aRouteResult seasideMimeType ] ]! !

!WARestfulFilter methodsFor: 'handling' stamp: 'lr 7/26/2011 09:35'!
handleFiltered: aRequestContext
	self executeResult: (self
		routeForContext: aRequestContext
		ifAbsent: [ self noRouteFound: aRequestContext ])! !

!WARestfulFilter methodsFor: 'private' stamp: 'pmm 6/27/2010 12:09'!
isImplemented: aString
	^ WARoute httpMethodNames includes: aString! !

!WARestfulFilter methodsFor: 'handling' stamp: 'pmm 10/25/2010 07:05'!
noRouteFound: aRequestContext
	super handleFiltered: aRequestContext! !

!WARestfulFilter methodsFor: 'private' stamp: 'pmm 2/18/2012 14:20'!
routeForContext: aRequestContext ifAbsent: aNiladicBlock
	^ (WAByMethodRoutes routes: self routes)
		routeForContext: aRequestContext
		consume: self shouldConsumePath
		ifAbsent: aNiladicBlock! !

!WARestfulFilter methodsFor: 'accessing' stamp: 'lr 7/26/2011 12:21'!
routes
	"Answer a collection of routes for the receiver."

	^ routes ifNil: [ 
		self shouldCacheRoutes
			ifFalse: [ self createRoutes ]
			ifTrue: [ routes := self createRoutes ] ]! !

!WARestfulFilter methodsFor: 'private' stamp: 'lr 7/26/2011 12:19'!
shouldCacheRoutes
	"Answer a boolean if the routes should be cached by the receiver."

	^ false! !

!WARestfulFilter methodsFor: 'private' stamp: 'pmm 2/18/2012 14:19'!
shouldConsumePath
	"Answer whether the request path should be consumed if a route is found."
	^ false! !

WASystemConfiguration subclass: #WARestfulConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Handler'!

WARequestHandler subclass: #WARestfulHandler
	instanceVariableNames: 'routes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Handler'!

!WARestfulHandler methodsFor: 'private' stamp: 'pmm 8/27/2011 09:55'!
createRoutes
	"Creates a collection of routes for the receiver. Override this method in subclasses to explicitely create the routes instead of using the default implementation that builds the routes using annotated methods (pragmas)."

	^ GRPlatform current createRoutesFrom: self class to: WARestfulHandler! !

!WARestfulHandler methodsFor: 'handling' stamp: 'pmm 2/19/2012 09:42'!
executeResult: aRouteResult
	self requestContext respond: [ :response |
		| mimeType |
		mimeType := aRouteResult seasideMimeType.
		mimeType isNil
			ifTrue: [
				response
					document: (aRouteResult sendMessageTo: self) ]
			ifFalse: [
				response
					document: (aRouteResult sendMessageTo: self)
					mimeType: aRouteResult seasideMimeType ] ]! !

!WARestfulHandler methodsFor: 'handling' stamp: 'lr 7/26/2011 09:35'!
handleFiltered: aRequestContext
	self executeResult: (self
		routeForContext: aRequestContext
		ifAbsent: [ self noRouteFound: aRequestContext ])! !

!WARestfulHandler methodsFor: 'private' stamp: 'pmm 6/27/2010 12:09'!
isImplemented: aString
	^ WARoute httpMethodNames includes: aString! !

!WARestfulHandler methodsFor: 'handling' stamp: 'pmm 10/25/2010 07:05'!
noRouteFound: aRequestContext
	aRequestContext responseGenerator
		notFound;
		respond! !

!WARestfulHandler methodsFor: 'private' stamp: 'pmm 2/18/2012 14:20'!
routeForContext: aRequestContext ifAbsent: aNiladicBlock
	^ (WAByMethodRoutes routes: self routes)
		routeForContext: aRequestContext
		consume: self shouldConsumePath
		ifAbsent: aNiladicBlock! !

!WARestfulHandler methodsFor: 'accessing' stamp: 'lr 7/26/2011 12:21'!
routes
	"Answer a collection of routes for the receiver."

	^ routes ifNil: [ 
		self shouldCacheRoutes
			ifFalse: [ self createRoutes ]
			ifTrue: [ routes := self createRoutes ] ]! !

!WARestfulHandler methodsFor: 'private' stamp: 'lr 7/26/2011 12:21'!
shouldCacheRoutes
	"Answer a boolean if the routes should be cached by the receiver."

	^ false! !

!WARestfulHandler methodsFor: 'private' stamp: 'pmm 2/18/2012 14:19'!
shouldConsumePath
	"Answer whether the request path should be consumed if a route is found."
	^ true! !

WAError subclass: #WAArgumentNotFoundError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

WAObject subclass: #WAByMethodRoutes
	instanceVariableNames: 'fixedContainers flexibleContainers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

!WAByMethodRoutes commentStamp: 'DamienPollet 6/27/2011 16:31' prior: 0!
A WAByMethodRoutes is a collection of routes first organized by HTTP method and then by number of URL path elements. It allows users to look up possible routes for a given HTTP request.

See also WARouteResult and WARouteContainer.

Instance Variables
	routes:		<Dictionary<String, SortedCollection<WARouteContainer>>

routes
	- the routes keyed by HTTP method, sorted by number of path elements
!

!WAByMethodRoutes class methodsFor: 'instance creation' stamp: 'pmm 9/8/2009 22:12'!
routes: aCollectionOfRoutes
	^ self basicNew initializeWithRoutes: aCollectionOfRoutes! !

!WAByMethodRoutes methodsFor: 'private' stamp: 'pmm 3/22/2011 14:40'!
addRoute: aRoute to: aDictionary
	| methodRoutes subRoutes |
	methodRoutes := aDictionary
		at: aRoute method
		ifAbsentPut: [ Dictionary new ].
	subRoutes := methodRoutes at: aRoute pathElementCount ifAbsentPut: [ OrderedCollection new ].
	subRoutes add: aRoute! !

!WAByMethodRoutes methodsFor: 'private' stamp: 'lr 7/26/2011 14:07'!
buildContainers: aDictionary
	| result |
	result := Dictionary new.
	aDictionary keysAndValuesDo: [ :method :subroutes |
		| methodRoutes |
		methodRoutes := result
			at: method
			ifAbsentPut: [
				SortedCollection sortBlock: [ :a :b |
					a pathElementCount <= b pathElementCount ] ].
		subroutes do: [ :each |
			methodRoutes add: (WARouteContainer routes: each) ] ].
	^ result! !

!WAByMethodRoutes methodsFor: 'private' stamp: 'pmm 3/22/2011 20:33'!
fixedRoutesForContext: aRequestContext
	| elementCount routesForMethod |
	elementCount := aRequestContext consumer peekToEnd size.
	routesForMethod := fixedContainers at: aRequestContext request method ifAbsent: [ ^ nil ].
	^ routesForMethod
		detect: [ :each |
			each pathElementCount = elementCount ]
		ifNone: [ nil ]! !

!WAByMethodRoutes methodsFor: 'private' stamp: 'pmm 7/10/2011 16:45'!
flexibleRoutesForContext: aRequestContext
	| elementCount routesForMethod startIndex endIndex |
	elementCount := aRequestContext consumer peekToEnd size.
	routesForMethod := flexibleContainers at: aRequestContext request method ifAbsent: [ ^ nil ].
	routesForMethod keysAndValuesDo: [ :index :each |
		(each pathElementCount >= (elementCount - 1) and: [ startIndex isNil ])
			ifTrue: [ startIndex := index ].
		(each pathElementCount > elementCount and: [ endIndex notNil ])
			ifTrue: [ endIndex := index ] ].
	startIndex isNil
		ifTrue: [ ^ nil ].
	endIndex isNil
		ifTrue: [ endIndex := routesForMethod size ].
	^ routesForMethod copyFrom: startIndex to: endIndex
	! !

!WAByMethodRoutes methodsFor: 'initialization' stamp: 'pmm 3/22/2011 20:25'!
initializeWithRoutes: aCollectionOfRoutes
	| standardRouteBuilder flexibleRouteBuilder |
	self initialize.
	standardRouteBuilder := Dictionary new.
	flexibleRouteBuilder := Dictionary new.
	aCollectionOfRoutes do: [ :each |
		each matchesFlexibleNumberOfPathElements
			ifTrue: [ self addRoute: each to: flexibleRouteBuilder ]
			ifFalse: [ self addRoute: each to: standardRouteBuilder ] ].
	fixedContainers := self buildContainers: standardRouteBuilder.
	flexibleContainers := self buildContainers: flexibleRouteBuilder! !

!WAByMethodRoutes methodsFor: 'private' stamp: 'pmm 3/22/2011 21:01'!
mergedRoutesForContext: aRequestContext
	| routes fixed flexibles |
	routes := OrderedCollection new.
	fixed := self fixedRoutesForContext: aRequestContext.
	fixed isNil ifFalse: [
		routes add: fixed ].
	flexibles := self flexibleRoutesForContext: aRequestContext.
	flexibles isNil ifFalse: [
		routes addAll: flexibles ].
	routes isEmpty
		ifTrue: [ ^ nil ].
	routes size = 1
		ifTrue: [ ^ routes first ].
	^ WARouteContainer routes: (routes gather: [ :each | each routes ])! !

!WAByMethodRoutes methodsFor: 'private' stamp: 'lr 7/26/2011 12:17'!
privateRouteForContext: aRequestContext ifAbsent: aNiladicBlock
	| routeContainer parameters elements |
	routeContainer := self mergedRoutesForContext: aRequestContext.
	routeContainer isNil
		ifTrue: [ ^ aNiladicBlock value ].
	parameters := aRequestContext request url queryFields.
	elements := aRequestContext consumer peekToEnd.
	^ WARouteResult
		route: (routeContainer
			routeForElements: elements
			parameters: parameters
			contentType: aRequestContext request contentType 
			accept: aRequestContext request accept
			ifAbsent: [ ^ aNiladicBlock value ])
		elements: elements
		parameters: parameters! !

!WAByMethodRoutes methodsFor: 'public' stamp: 'pmm 2/18/2012 14:11'!
routeForContext: aRequestContext consume: aBoolean ifAbsent: aNiladicBlock
	| found result |
	found := true.
	result := self
		privateRouteForContext: aRequestContext
		ifAbsent: [
			found := false.
			aNiladicBlock value ].
	(found and: [ aBoolean ]) ifTrue: [
		"we found something this means we consume the entire path"
		aRequestContext consumer upToEnd ].
	^ result! !

WAObject subclass: #WAMatch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

WAMatch subclass: #WACompositeMimeTypeMatch
	instanceVariableNames: 'matches'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

!WACompositeMimeTypeMatch class methodsFor: 'instance creation' stamp: 'lr 7/25/2011 11:05'!
matches: aCollection
	^ self basicNew initializeWithMatches: aCollection! !

!WACompositeMimeTypeMatch methodsFor: 'initialization' stamp: 'pmm 10/17/2010 14:01'!
initializeWithMatches: aCollection
	self initialize.
	matches := aCollection! !

!WACompositeMimeTypeMatch methodsFor: 'testing' stamp: 'lr 7/25/2011 10:54'!
matches: aMimeType
	^ matches anySatisfy: [ :each | each matches: aMimeType ]! !

!WACompositeMimeTypeMatch methodsFor: 'accessing' stamp: 'pmm 10/17/2010 19:35'!
priorityFor: aMimeType
	| matched |
	matched := matches select: [ :each | each matches: aMimeType ].
	matched isEmpty
		ifTrue: [ ^ -1 ].
	matched sort: [ :a :b |
		a priority <= b priority ].
	^ matched last priority! !

!WACompositeMimeTypeMatch methodsFor: 'accessing' stamp: 'pmm 7/28/2011 22:00'!
seasideMimeType
	"We don't know which one to take."
	^ nil! !

!WAMatch class methodsFor: 'private' stamp: 'pmm 6/13/2010 10:01'!
argument: aString notFoundInd: aCollectionOfStrings
	WAArgumentNotFoundError signal: 'argument "', aString, '" was not found in ', aCollectionOfStrings greaseString! !

!WAMatch class methodsFor: 'private' stamp: 'lr 7/25/2011 19:49'!
targetIndexOf: aString arguments: aCollectionOfStrings
	aString do: [ :each |
		each isDigit ifFalse: [
			| index |
			index := aCollectionOfStrings indexOf: aString.
			index isZero ifTrue: [
				self argument: aString notFoundInd: aCollectionOfStrings ].
			^ index ] ].
	^ aString asNumber! !

WAMatch subclass: #WAMimeTypeMatch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

WAMimeTypeMatch subclass: #WAFullMimeTypeMatch
	instanceVariableNames: 'main sub'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

!WAFullMimeTypeMatch class methodsFor: 'instance creation' stamp: 'lr 7/25/2011 11:05'!
main: aMainString sub: aSubString
	^ self basicNew initializeWithMain: aMainString sub: aSubString! !

!WAFullMimeTypeMatch methodsFor: 'initialization' stamp: 'pmm 10/6/2010 11:42'!
initializeWithMain: aMainString sub: aSubString
	self initialize.
	main := aMainString.
	sub := aSubString! !

!WAFullMimeTypeMatch methodsFor: 'testing' stamp: 'lr 7/25/2011 10:55'!
matches: aMimeType
	^ (aMimeType main = '*'
		or: [ aMimeType main = main ])
		and: [
			aMimeType sub = '*'
				or: [ aMimeType sub = sub ] ]! !

!WAFullMimeTypeMatch methodsFor: 'printing' stamp: 'NickAger 8/13/2011 16:09'!
printOn: aStream
	super printOn: aStream.

	aStream 
		nextPutAll: ' (mimeType: '; print: self seasideMimeType;
		nextPutAll: ' priority: '; print: self priority;
		nextPut: $)! !

!WAFullMimeTypeMatch methodsFor: 'accessing' stamp: 'lr 7/25/2011 10:54'!
priority
	^ 3! !

!WAFullMimeTypeMatch methodsFor: 'accessing' stamp: 'pmm 7/28/2011 21:42'!
priorityFor: aMimeType
	^ (aMimeType main = main
		and: [ aMimeType sub = sub ])
			ifTrue: [ self priority ]
			ifFalse: [ -1 ]! !

!WAFullMimeTypeMatch methodsFor: 'accessing' stamp: 'pmm 7/28/2011 21:53'!
seasideMimeType
	^ WAMimeType main: main sub: sub! !

WAMimeTypeMatch subclass: #WAMainMimeTypeMatch
	instanceVariableNames: 'main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

!WAMainMimeTypeMatch class methodsFor: 'instance creation' stamp: 'lr 7/25/2011 11:05'!
main: aMainString
	^ self basicNew initializeWithMain: aMainString! !

!WAMainMimeTypeMatch methodsFor: 'initialization' stamp: 'pmm 10/6/2010 11:44'!
initializeWithMain: aMainString
	self initialize.
	main := aMainString! !

!WAMainMimeTypeMatch methodsFor: 'testing' stamp: 'lr 7/25/2011 10:54'!
matches: aMimeType
	^ aMimeType main = '*' or: [ aMimeType main = main ]! !

!WAMainMimeTypeMatch methodsFor: 'printing' stamp: 'NickAger 8/13/2011 16:10'!
printOn: aStream
	super printOn: aStream.

	aStream 
		nextPutAll: ' (mimeType: '; print: (WAMimeType main: main sub: '*');
		nextPutAll: ' priority: '; print: self priority;
		nextPut: $)! !

!WAMainMimeTypeMatch methodsFor: 'accessing' stamp: 'lr 7/25/2011 10:54'!
priority
	^ 2! !

!WAMainMimeTypeMatch methodsFor: 'accessing' stamp: 'pmm 8/21/2011 11:36'!
priorityFor: aMimeType
	^ aMimeType main = main
			ifTrue: [ self priority ]
			ifFalse: [ -1 ]! !

!WAMimeTypeMatch class methodsFor: 'instance creation' stamp: 'lr 7/25/2011 19:03'!
fromMimeType: aMimeType
	^ aMimeType main = '*'
		ifTrue: [
			aMimeType sub = '*'
				ifTrue: [ WAWildcardMimeTypeMatch new ]
				ifFalse: [ WASubMimeTypeMatch
					sub: aMimeType sub ] ]
		ifFalse: [
			aMimeType sub = '*'
				ifTrue: [ WAMainMimeTypeMatch
					main: aMimeType main ]
				ifFalse: [ WAFullMimeTypeMatch
					main: aMimeType main
					sub: aMimeType sub ] ]! !

!WAMimeTypeMatch class methodsFor: 'instance creation' stamp: 'lr 7/25/2011 11:05'!
fromString: aString
	^ self fromMimeType: (WAMimeType fromString: aString)! !

!WAMimeTypeMatch methodsFor: 'testing' stamp: 'pmm 10/6/2010 12:08'!
matches: aMimeType
	self subclassResponsibility! !

!WAMimeTypeMatch methodsFor: 'accessing' stamp: 'pmm 10/6/2010 11:31'!
priority
	self subclassResponsibility! !

!WAMimeTypeMatch methodsFor: 'accessing' stamp: 'pmm 1/22/2012 21:57'!
priorityFor: aMimeType
	self subclassResponsibility! !

!WAMimeTypeMatch methodsFor: 'accessing' stamp: 'pmm 7/28/2011 21:53'!
seasideMimeType
	"Works only for exact matches."
	^ nil! !

WAMimeTypeMatch subclass: #WASubMimeTypeMatch
	instanceVariableNames: 'sub'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

!WASubMimeTypeMatch class methodsFor: 'instance creation' stamp: 'lr 7/25/2011 11:05'!
sub: aSubString
	^ self basicNew initializeWithSub: aSubString! !

!WASubMimeTypeMatch methodsFor: 'initialization' stamp: 'pmm 10/6/2010 11:43'!
initializeWithSub: aSubString
	self initialize.
	sub := aSubString! !

!WASubMimeTypeMatch methodsFor: 'testing' stamp: 'lr 7/25/2011 10:54'!
matches: aMimeType
	^ aMimeType sub = '*' or: [ aMimeType sub = sub ]! !

!WASubMimeTypeMatch methodsFor: 'printing' stamp: 'NickAger 8/13/2011 16:11'!
printOn: aStream
	super printOn: aStream.

	aStream 
		nextPutAll: ' (mimeType: '; print: (WAMimeType main: '*' sub: sub);
		nextPutAll: ' priority: '; print: self priority;
		nextPut: $)! !

!WASubMimeTypeMatch methodsFor: 'accessing' stamp: 'lr 7/25/2011 10:54'!
priority
	^ 2! !

!WASubMimeTypeMatch methodsFor: 'accessing' stamp: 'pmm 8/21/2011 11:36'!
priorityFor: aMimeType
	^ aMimeType sub = sub
			ifTrue: [ self priority ]
			ifFalse: [ -1 ]! !

WAMimeTypeMatch subclass: #WAWildcardMimeTypeMatch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

!WAWildcardMimeTypeMatch methodsFor: 'testing' stamp: 'lr 7/25/2011 10:55'!
matches: aMimeType
	^ true! !

!WAWildcardMimeTypeMatch methodsFor: 'printing' stamp: 'NickAger 8/13/2011 16:11'!
printOn: aStream
	super printOn: aStream.

	aStream 
		nextPutAll: ' (mimeType: '; print: (WAMimeType main: '*' sub: '*');
		nextPutAll: ' priority: '; print: self priority;
		nextPut: $)! !

!WAWildcardMimeTypeMatch methodsFor: 'accessing' stamp: 'lr 7/25/2011 10:55'!
priority
	^ 1! !

!WAWildcardMimeTypeMatch methodsFor: 'accessing' stamp: 'pmm 10/17/2010 14:15'!
priorityFor: aMimeType
	^ self priority! !

WAMatch subclass: #WAPPathMatch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

WAPPathMatch subclass: #WAExactPathMatch
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

!WAExactPathMatch class methodsFor: 'instance creation' stamp: 'pmm 9/7/2009 00:07'!
fromString: aString
	^ self basicNew inititializeWith: aString! !

!WAExactPathMatch class methodsFor: 'instance creation' stamp: 'pmm 6/13/2010 09:30'!
fromString: aString index: anInteger arguments: aCollectionOfStrings
	^ self fromString: aString! !

!WAExactPathMatch methodsFor: 'accessing' stamp: 'pmm 9/8/2009 18:30'!
argumentCount
	^ 0! !

!WAExactPathMatch methodsFor: 'initialization' stamp: 'pmm 2/16/2011 22:23'!
inititializeWith: aString
	self initialize.
	element := aString! !

!WAExactPathMatch methodsFor: 'public' stamp: 'pmm 3/22/2011 10:06'!
mapArgumentsWithElements: aCollection into: anArray usingOffset: anInteger
	"ignore"! !

!WAExactPathMatch methodsFor: 'testing' stamp: 'pmm 9/7/2009 00:07'!
matches: aString
	^ element = aString! !

!WAExactPathMatch methodsFor: 'accessing' stamp: 'pmm 6/26/2010 17:45'!
priority
	^ 3! !

WAPPathMatch subclass: #WAOrPathMatch
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

!WAOrPathMatch class methodsFor: 'instance creation' stamp: 'pmm 3/21/2011 20:43'!
fromString: aString
	^ self basicNew inititializeWith: aString! !

!WAOrPathMatch class methodsFor: 'instance creation' stamp: 'pmm 3/21/2011 20:43'!
fromString: aString index: anInteger arguments: aCollectionOfStrings
	^ self fromString: aString! !

!WAOrPathMatch methodsFor: 'accessing' stamp: 'pmm 3/21/2011 20:43'!
argumentCount
	^ 0! !

!WAOrPathMatch methodsFor: 'initialization' stamp: 'pmm 3/21/2011 21:14'!
inititializeWith: aString
	self initialize.
	elements := aString subStrings: '|'.
	"cut off leading $[ from first"
	elements at: 1 put: (elements first allButFirst).
	"cut off trailing $] from first"
	elements at: elements size put: (elements last allButLast).! !

!WAOrPathMatch methodsFor: 'public' stamp: 'pmm 3/22/2011 10:07'!
mapArgumentsWithElements: aCollection into: anArray usingOffset: anInteger
	"ignore"! !

!WAOrPathMatch methodsFor: 'testing' stamp: 'pmm 3/21/2011 20:44'!
matches: aString
	^ elements includes: aString! !

!WAOrPathMatch methodsFor: 'accessing' stamp: 'pmm 3/21/2011 20:43'!
priority
	^ 3! !

!WAPPathMatch class methodsFor: 'instance creation' stamp: 'pmm 6/27/2010 00:28'!
fromString: aString index: anInteger arguments: aCollectionOfStrings
	^ (self matchClassFor: aString)
		fromString: aString index: anInteger arguments: aCollectionOfStrings! !

!WAPPathMatch class methodsFor: 'private' stamp: 'pmm 3/22/2011 09:15'!
matchClassFor: aString
	aString isEmpty ifTrue: [ ^ WAExactPathMatch  ].
	aString first = ${
		ifTrue: [
			| index |
			index := aString indexOf: $} startingAt: 2.
			index = aString size
				"{name}"
				ifTrue: [ ^ WAFullPlaceholderPathMatch ].
			index isZero
				"{name}suffix"
				ifFalse: [ ^ WASuffixPlaceholderPathMatch ] ].
	"prefix{name}"
	(aString last = $}
		and: [ (aString indexOf: ${) isZero not ])
			ifTrue: [ ^ WAPrefixPlaceholderPathMatch ].
	"[option1|option2]"
	(aString first = $[
		and: [ aString last = $]
		and: [ aString includes: $| ] ])
			ifTrue: [ ^ WAOrPathMatch ].
	"*name*"
	(aString first = $*
		and: [ aString last = $* ])
			ifTrue: [ ^ WAMultiPlaceholderPathMatch ].
	^ WAExactPathMatch! !

!WAPPathMatch methodsFor: 'accessing' stamp: 'pmm 9/8/2009 18:30'!
argumentCount
	self subclassResponsibility! !

!WAPPathMatch methodsFor: 'public' stamp: 'pmm 3/22/2011 10:06'!
mapArgumentsWithElements: aCollection into: anArray
	self mapArgumentsWithElements: aCollection into: anArray usingOffset: 0! !

!WAPPathMatch methodsFor: 'public' stamp: 'pmm 3/22/2011 10:06'!
mapArgumentsWithElements: aCollection into: anArray usingOffset: anInteger
	self subclassResponsibility! !

!WAPPathMatch methodsFor: 'testing' stamp: 'pmm 9/6/2009 23:57'!
matches: aString
	self subclassResponsibility! !

!WAPPathMatch methodsFor: 'testing' stamp: 'pmm 3/22/2011 09:08'!
matchesJustOneElement
	^ true! !

!WAPPathMatch methodsFor: 'printing' stamp: 'NickAger 8/13/2011 15:12'!
printOn: aStream 
	super printOn: aStream.
	
	aStream
		nextPutAll: ' (argumentCount: '; print: self argumentCount;
		nextPutAll: ' matchesJustOneElement: '; print: self matchesJustOneElement;
		nextPutAll: ' priority: '; print: self priority;
		nextPut: $)! !

!WAPPathMatch methodsFor: 'accessing' stamp: 'pmm 9/6/2009 21:49'!
priority
	self subclassResponsibility! !

WAPPathMatch subclass: #WAPlaceholderPathMatch
	instanceVariableNames: 'sourceIndex targetIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

WAPlaceholderPathMatch subclass: #WAFullPlaceholderPathMatch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

!WAFullPlaceholderPathMatch class methodsFor: 'instance creation' stamp: 'pmm 6/27/2010 10:09'!
fromString: aString index: anInteger arguments: aCollectionOfStrings
	^ self
		source: anInteger
		target: (self
			targetIndexOf: (aString copyFrom: 2 to: aString size - 1)
			arguments: aCollectionOfStrings)! !

!WAFullPlaceholderPathMatch class methodsFor: 'instance creation' stamp: 'pmm 6/27/2010 10:12'!
source: anFirstInteger target: aSecondInteger
	^ self basicNew initializeWithSourceIndex: anFirstInteger targetIndex: aSecondInteger! !

!WAFullPlaceholderPathMatch methodsFor: 'public' stamp: 'pmm 3/22/2011 10:20'!
mapArgumentsWithElements: aCollection into: anArray usingOffset: anInteger
	anArray
		at: targetIndex
		put: (aCollection at: sourceIndex + anInteger)! !

!WAFullPlaceholderPathMatch methodsFor: 'testing' stamp: 'pmm 6/26/2010 17:45'!
matches: aString
	^ true! !

!WAFullPlaceholderPathMatch methodsFor: 'accessing' stamp: 'pmm 3/20/2011 14:10'!
priority
	^ 2! !

WAPlaceholderPathMatch subclass: #WAMultiPlaceholderPathMatch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

!WAMultiPlaceholderPathMatch class methodsFor: 'instance creation' stamp: 'pmm 3/22/2011 09:25'!
fromString: aString index: anInteger arguments: aCollectionOfStrings
	^ self
		source: anInteger
		target: (self
			targetIndexOf: (aString copyFrom: 2 to: aString size - 1)
			arguments: aCollectionOfStrings)! !

!WAMultiPlaceholderPathMatch class methodsFor: 'instance creation' stamp: 'pmm 3/22/2011 09:25'!
source: anFirstInteger target: aSecondInteger
	^ self basicNew initializeWithSourceIndex: anFirstInteger targetIndex: aSecondInteger! !

!WAMultiPlaceholderPathMatch methodsFor: 'public' stamp: 'pmm 3/22/2011 10:11'!
mapArgumentsWithElements: aCollection into: anArray usingOffset: anInteger
	anArray
		at: targetIndex
		put: (aCollection copyFrom: sourceIndex to: sourceIndex + anInteger)! !

!WAMultiPlaceholderPathMatch methodsFor: 'testing' stamp: 'pmm 3/22/2011 09:45'!
matches: aString
	^ true! !

!WAMultiPlaceholderPathMatch methodsFor: 'testing' stamp: 'pmm 3/22/2011 09:08'!
matchesJustOneElement
	^ false! !

!WAMultiPlaceholderPathMatch methodsFor: 'accessing' stamp: 'pmm 3/20/2011 14:12'!
priority
	^ 1! !

!WAPlaceholderPathMatch methodsFor: 'accessing' stamp: 'pmm 9/8/2009 18:30'!
argumentCount
	^ 1! !

!WAPlaceholderPathMatch methodsFor: 'initialization' stamp: 'pmm 2/13/2011 10:32'!
initializeWithSourceIndex: anFirstInteger targetIndex: aSecondInteger
	self initialize.
	sourceIndex := anFirstInteger.
	targetIndex := aSecondInteger! !

!WAPlaceholderPathMatch methodsFor: 'accessing' stamp: 'pmm 9/10/2009 09:05'!
sourceIndex
	^ sourceIndex! !

!WAPlaceholderPathMatch methodsFor: 'accessing' stamp: 'pmm 9/10/2009 09:11'!
targetIndex
	^ targetIndex! !

WAPlaceholderPathMatch subclass: #WAPrefixPlaceholderPathMatch
	instanceVariableNames: 'prefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

!WAPrefixPlaceholderPathMatch class methodsFor: 'instance creation' stamp: 'pmm 6/27/2010 10:20'!
fromString: aString index: anInteger arguments: aCollectionOfStrings
	| prefix |
	prefix := aString copyUpTo: ${.
	^ self
		source: anInteger
		target: (self
			targetIndexOf: (aString copyFrom: prefix size + 2 to: aString size - 1)
			arguments: aCollectionOfStrings)
		prefix: prefix! !

!WAPrefixPlaceholderPathMatch class methodsFor: 'instance creation' stamp: 'pmm 6/27/2010 10:14'!
source: anFirstInteger target: aSecondInteger prefix: aString
	^ self basicNew
		initializeWithSourceIndex: anFirstInteger
		targetIndex: aSecondInteger
		prefix: aString! !

!WAPrefixPlaceholderPathMatch methodsFor: 'initialization' stamp: 'pmm 2/13/2011 10:32'!
initializeWithSourceIndex: anFirstInteger targetIndex: aSecondInteger prefix: aString
	self initializeWithSourceIndex: anFirstInteger targetIndex: aSecondInteger.
	prefix := aString! !

!WAPrefixPlaceholderPathMatch methodsFor: 'public' stamp: 'pmm 3/22/2011 10:07'!
mapArgumentsWithElements: aCollection into: anArray usingOffset: anInteger
	| value |
	value := aCollection at: sourceIndex + anInteger.
	anArray
		at: targetIndex
		put: (value copyFrom: prefix size + 1 to: value size)! !

!WAPrefixPlaceholderPathMatch methodsFor: 'testing' stamp: 'lr 7/26/2011 14:06'!
matches: aString
	^ (aString size > prefix size)
		and: [ aString beginsWithSubCollection: prefix ]! !

!WAPrefixPlaceholderPathMatch methodsFor: 'accessing' stamp: 'pmm 3/20/2011 14:11'!
priority
	^ 3! !

WAPlaceholderPathMatch subclass: #WASuffixPlaceholderPathMatch
	instanceVariableNames: 'suffix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

!WASuffixPlaceholderPathMatch class methodsFor: 'instance creation' stamp: 'pmm 6/29/2010 08:16'!
fromString: aString index: anInteger arguments: aCollectionOfStrings
	| suffix |
	suffix := aString copyAfter: $}.
	^ self
		source: anInteger
		target: (self
			targetIndexOf: (aString copyFrom: 2 to: aString size - suffix size - 1)
			arguments: aCollectionOfStrings)
		suffix: suffix! !

!WASuffixPlaceholderPathMatch class methodsFor: 'instance creation' stamp: 'pmm 6/27/2010 10:14'!
source: anFirstInteger target: aSecondInteger suffix: aString
	^ self basicNew
		initializeWithSourceIndex: anFirstInteger
		targetIndex: aSecondInteger
		suffix: aString! !

!WASuffixPlaceholderPathMatch methodsFor: 'initialization' stamp: 'pmm 2/13/2011 10:32'!
initializeWithSourceIndex: anFirstInteger targetIndex: aSecondInteger suffix: aString
	self initializeWithSourceIndex: anFirstInteger targetIndex: aSecondInteger.
	suffix := aString! !

!WASuffixPlaceholderPathMatch methodsFor: 'public' stamp: 'pmm 3/22/2011 10:08'!
mapArgumentsWithElements: aCollection into: anArray usingOffset: anInteger
	| value |
	value := aCollection at: sourceIndex + anInteger.
	anArray
		at: targetIndex
		put: (value copyFrom: 1 to: value size - suffix size)! !

!WASuffixPlaceholderPathMatch methodsFor: 'testing' stamp: 'lr 7/26/2011 14:06'!
matches: aString
	^ (aString size > suffix size)
		and: [ aString endsWithSubCollection: suffix ]! !

!WASuffixPlaceholderPathMatch methodsFor: 'accessing' stamp: 'pmm 3/20/2011 14:11'!
priority
	^ 3! !

WAMatch subclass: #WAParameterMatch
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

WAParameterMatch subclass: #WAExactParameterMatch
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

!WAExactParameterMatch class methodsFor: 'instance creation' stamp: 'pmm 10/30/2010 18:59'!
name: aNameString value: aValueString arguments: aCollectionOfStrings 
	^ self basicNew initializeWithName: aNameString value: aValueString! !

!WAExactParameterMatch methodsFor: 'accessing' stamp: 'pmm 9/8/2009 18:29'!
argumentCount
	^ 0! !

!WAExactParameterMatch methodsFor: 'initialization' stamp: 'pmm 2/13/2011 10:31'!
initializeWithName: aNameString value: aValueString
	self initializeWithName: aNameString.
	value := aValueString! !

!WAExactParameterMatch methodsFor: 'public' stamp: 'pmm 9/9/2009 07:06'!
mapArgumentsWithParameters: aDictionary into: anArray
	"ignore"! !

!WAExactParameterMatch methodsFor: 'testing' stamp: 'lr 7/25/2011 11:05'!
matchesName: aNameString value: aValueString
	^ name = aNameString and: [ value = aValueString ]! !

!WAParameterMatch class methodsFor: 'private' stamp: 'pmm 9/8/2009 13:20'!
isPattern: aString
	^ aString isEmpty not
		and: [ aString first = ${
		and: [ aString last = $} ] ]! !

!WAParameterMatch class methodsFor: 'instance creation' stamp: 'pmm 6/13/2010 09:57'!
name: aKeyString value: aValueString arguments: aCollectionOfStrings 
	^ ((self isPattern: aValueString)
		ifTrue: [ WAPlaceholderParameterMatch ]
		ifFalse: [ WAExactParameterMatch ]) name: aKeyString value: aValueString arguments: aCollectionOfStrings ! !

!WAParameterMatch methodsFor: 'accessing' stamp: 'pmm 9/8/2009 18:29'!
argumentCount
	self subclassResponsibility! !

!WAParameterMatch methodsFor: 'initialization' stamp: 'pmm 2/13/2011 10:31'!
initializeWithName: aString
	self initialize.
	name := aString! !

!WAParameterMatch methodsFor: 'public' stamp: 'pmm 9/9/2009 07:05'!
mapArgumentsWithParameters: aDictionary into: anArray
	self subclassResponsibility! !

!WAParameterMatch methodsFor: 'testing' stamp: 'pmm 9/8/2009 13:06'!
matchesName: aNameString value: aValueString
	self subclassResponsibility! !

WAParameterMatch subclass: #WAPlaceholderParameterMatch
	instanceVariableNames: 'index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

!WAPlaceholderParameterMatch class methodsFor: 'instance creation' stamp: 'pmm 10/30/2010 19:00'!
name: aString index: anInteger
	^ self basicNew initializeWithName: aString index: anInteger! !

!WAPlaceholderParameterMatch class methodsFor: 'instance creation' stamp: 'pmm 6/13/2010 09:51'!
name: aNameString value: aValueString arguments: aCollectionOfStrings
	^ self
		name: aNameString
		index: (self
			targetIndexOf: (aValueString copyFrom: 2 to: aValueString size - 1)
			arguments: aCollectionOfStrings)! !

!WAPlaceholderParameterMatch methodsFor: 'accessing' stamp: 'pmm 9/8/2009 18:30'!
argumentCount
	^ 1! !

!WAPlaceholderParameterMatch methodsFor: 'accessing' stamp: 'pmm 6/13/2010 09:53'!
index
	^ index! !

!WAPlaceholderParameterMatch methodsFor: 'initialization' stamp: 'pmm 2/13/2011 10:38'!
initializeWithName: aString index: anInteger
	self initializeWithName: aString.
	index := anInteger! !

!WAPlaceholderParameterMatch methodsFor: 'public' stamp: 'pmm 9/9/2009 07:06'!
mapArgumentsWithParameters: aDictionary into: anArray
	anArray at: index put: (aDictionary at: name)! !

!WAPlaceholderParameterMatch methodsFor: 'testing' stamp: 'lr 7/25/2011 11:05'!
matchesName: aNameString value: aValueString
	^ name = aNameString! !

WAObject subclass: #WARoute
	instanceVariableNames: 'method selector produces consumes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

!WARoute commentStamp: 'pmm 7/28/2011 20:33' prior: 0!
I am a message that can be sent if I match a request. Message arguments can be taken from the request.

Instance Variables:
	method		<String>
	selector	<Symbol>
	produces 	<WAMatch>
	consumes 	<WAMatch>
		
method
	- The HTTP method on which to follow this route, eg. 'GET'

selector
	- The selector to perform, eg. #index
	
produces
	- The MIME type this route produces (Content-Type HTTP header)
	
consumes
	- The MIME type this route accepts (Accept HTTP header)!

WARoute subclass: #WAComplexRoute
	instanceVariableNames: 'pathMatches parameterMatches isOverlyComplex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

!WAComplexRoute class methodsFor: 'examples' stamp: 'lr 7/25/2011 11:05'!
example
	^ self
		get: '/{3}/_all_docs?startkey={1}&limit={2}'
		selector: #getAllDocumentsStartingAt:limitedTo:inDatabase:! !

!WAComplexRoute class methodsFor: 'instance creation' stamp: 'lr 7/25/2011 11:05'!
method: aMethodString selector: aSymbol pattern: aPatternString
	^ self
		method: aMethodString
		selector: aSymbol
		url: (WAUrl absolute: aPatternString)
		arguments: #()
		produces: WAWildcardMimeTypeMatch new
		consumes: WAWildcardMimeTypeMatch new! !

!WAComplexRoute class methodsFor: 'instance creation' stamp: 'lr 7/25/2011 11:05'!
method: aMethodString selector: aSymbol pattern: aPatternString arguments: aCollectionOfStrings produces: aProducesMimeTypeMatch consumes: aConsumesMimeTypeMatch 
	^ self
		method: aMethodString
		selector: aSymbol
		url: (WAUrl absolute: aPatternString)
		arguments: aCollectionOfStrings
		produces: aProducesMimeTypeMatch
		consumes: aConsumesMimeTypeMatch! !

!WAComplexRoute class methodsFor: 'instance creation' stamp: 'lr 7/25/2011 11:05'!
method: aString selector: aSymbol url: aUrl arguments: aCollectionOfStrings produces: aProducesMimeTypeMatch consumes: aConsumesMimeTypeMatch
	^ self basicNew
		initializeWithMethod: aString
		selector: aSymbol
		url: aUrl
		arguments: aCollectionOfStrings
		produces: aProducesMimeTypeMatch
		consumes: aConsumesMimeTypeMatch ! !

!WAComplexRoute methodsFor: 'accessing' stamp: 'lr 7/26/2011 14:07'!
argumentCount
	| count |
	count := 0.
	pathMatches do: [ :each |
		count := count + each argumentCount ].
	parameterMatches do: [ :each |
		count := count + each argumentCount ].
	^ count ! !

!WAComplexRoute methodsFor: 'private' stamp: 'pmm 8/27/2011 11:51'!
buildPathMatchesFrom: aUrl arguments: aCollectionOfStrings
	| index |
	index := 0.
	^ aUrl path collect: [ :each |
		index := index + 1.
		WAPPathMatch fromString: each index: index arguments: aCollectionOfStrings ]! !

!WAComplexRoute methodsFor: 'initialization' stamp: 'pmm 8/27/2011 11:47'!
initializeWithMethod: aString selector: aSymbol url: aUrl arguments: aCollectionOfStrings produces: aProducesMimeTypeMatch consumes: aConsumesMimeTypeMatch 
	self initializeWithMethod: aString selector: aSymbol produces: aProducesMimeTypeMatch consumes: aConsumesMimeTypeMatch.
	pathMatches := self buildPathMatchesFrom: aUrl arguments: aCollectionOfStrings.
	parameterMatches := Dictionary new.
	aUrl queryFields keysAndValuesDo: [ :key :value |
		parameterMatches
			at: key
			put: (WAParameterMatch name: key value: value arguments: aCollectionOfStrings) ].
	isOverlyComplex := pathMatches anySatisfy: [ :each |
		each matchesJustOneElement not ].! !

!WAComplexRoute methodsFor: 'private' stamp: 'pmm 3/22/2011 14:30'!
isOverlyComplex
	^ isOverlyComplex! !

!WAComplexRoute methodsFor: 'public' stamp: 'lr 7/26/2011 14:07'!
mapArgumentsWithElements: anArrayOfStrings parameters: aDictionary into: anArray
	| offset |
	offset := 0.
	pathMatches do: [ :each |
		each matchesJustOneElement ifFalse: [
			offset := anArrayOfStrings size - pathMatches size ].
		each mapArgumentsWithElements: anArrayOfStrings into: anArray usingOffset: offset ].
	parameterMatches do: [ :each |
		each mapArgumentsWithParameters: aDictionary into: anArray ]! !

!WAComplexRoute methodsFor: 'testing' stamp: 'pmm 3/22/2011 14:33'!
matchesFlexibleNumberOfPathElements
	^ self isOverlyComplex! !

!WAComplexRoute methodsFor: 'private' stamp: 'pmm 3/22/2011 09:17'!
matchesModeratelyComplex: aCollectionOfStrings
	
	pathMatches size = aCollectionOfStrings size
		ifFalse: [ ^ false ].
	pathMatches with: aCollectionOfStrings do: [ :match :each |
		(match matches: each)
			ifFalse: [ ^ false ] ].
	^ true! !

!WAComplexRoute methodsFor: 'private' stamp: 'pmm 7/10/2011 16:45'!
matchesOverlyComplex: aCollectionOfStrings
	| collectionIndex |

	pathMatches size > (aCollectionOfStrings size + 1)
		ifTrue: [ ^ false ].
	
	collectionIndex := 1.
	pathMatches keysAndValuesDo: [ :index :each |
		each matchesJustOneElement
			ifTrue: [
				(each matches: (aCollectionOfStrings at: collectionIndex))
					ifFalse: [ ^ false ].
				collectionIndex := collectionIndex + 1 ]
			ifFalse: [
				| matchEnd |
				matchEnd := aCollectionOfStrings size - (pathMatches size - index).
				collectionIndex to: matchEnd do: [ :submatchIndex |
					(each matches: (aCollectionOfStrings at: submatchIndex))
						ifFalse: [ ^ false ] ].
				collectionIndex := matchEnd + 1 ] ].

	^ true! !

!WAComplexRoute methodsFor: 'testing' stamp: 'pmm 9/8/2009 17:13'!
matchesParameters: aDictionary
	parameterMatches size = aDictionary size
		ifFalse: [ ^ false ].
	parameterMatches keysAndValuesDo: [ :name :match |
		| value |
		value := aDictionary at: name ifAbsent: [ ^ false ].
		(match matchesName: name value: value)
			ifFalse: [ ^ false ] ].
	^ true! !

!WAComplexRoute methodsFor: 'testing' stamp: 'lr 7/25/2011 10:56'!
matchesPath: aCollectionOfStrings
	^ self isOverlyComplex
		ifTrue: [ self matchesOverlyComplex: aCollectionOfStrings  ]
		ifFalse: [ self matchesModeratelyComplex: aCollectionOfStrings ]! !

!WAComplexRoute methodsFor: 'accessing' stamp: 'pmm 9/6/2009 22:09'!
pathElementCount
	^ pathMatches size! !

!WAComplexRoute methodsFor: 'printing' stamp: 'NickAger 8/13/2011 15:27'!
printOn: aStream
	super printOn: aStream.

	aStream 
		nextPutAll: ' (pathMatches: '; print: pathMatches;
		nextPutAll: ' parameterMatches: '; print: parameterMatches;
		nextPutAll: ' isOverlyComplex: '; print: self isOverlyComplex;
		nextPut: $)! !

!WAComplexRoute methodsFor: 'accessing' stamp: 'pmm 9/7/2009 00:27'!
priority
	^ pathMatches inject: 0 into: [ :sum :each |
		sum + each priority ]! !

!WARoute class methodsFor: 'instance creation' stamp: 'pmm 9/6/2009 23:52'!
copy: aSymbol
	^ WASimpleRoute method: 'COPY' selector: aSymbol! !

!WARoute class methodsFor: 'instance creation' stamp: 'pmm 9/6/2009 23:52'!
delete: aSymbol
	^ WASimpleRoute method: 'DELETE' selector: aSymbol! !

!WARoute class methodsFor: 'instance creation' stamp: 'pmm 9/9/2009 07:24'!
delete: aString selector: aSymbol
	^ WAComplexRoute
		method: 'DELETE'
		selector: aSymbol
		pattern: aString! !

!WARoute class methodsFor: 'instance creation' stamp: 'pmm 9/6/2009 23:52'!
get: aSymbol
	^ WASimpleRoute method: 'GET' selector: aSymbol! !

!WARoute class methodsFor: 'instance creation' stamp: 'pmm 9/7/2009 00:14'!
get: aString selector: aSymbol
	^ WAComplexRoute
		method: 'GET'
		selector: aSymbol
		pattern: aString! !

!WARoute class methodsFor: 'instance creation' stamp: 'pmm 5/30/2010 20:25'!
httpMethodNames
	^ #(
		COPY
		DELETE
		GET
		MOVE
		POST
		PUT
	)! !

!WARoute class methodsFor: 'instance creation' stamp: 'pmm 9/6/2009 23:52'!
move: aSymbol
	^ WASimpleRoute method: 'MOVE' selector: aSymbol! !

!WARoute class methodsFor: 'instance creation' stamp: 'pmm 9/6/2009 23:52'!
post: aSymbol
	^ WASimpleRoute method: 'POST' selector: aSymbol! !

!WARoute class methodsFor: 'instance creation' stamp: 'pmm 9/9/2009 07:23'!
post: aString selector: aSymbol
	^ WAComplexRoute
		method: 'POST'
		selector: aSymbol
		pattern: aString! !

!WARoute class methodsFor: 'instance creation' stamp: 'pmm 9/6/2009 23:52'!
put: aSymbol
	^ WASimpleRoute method: 'PUT' selector: aSymbol! !

!WARoute class methodsFor: 'instance creation' stamp: 'pmm 9/9/2009 07:23'!
put: aString selector: aSymbol
	^ WAComplexRoute
		method: 'PUT'
		selector: aSymbol
		pattern: aString! !

!WARoute methodsFor: 'accessing' stamp: 'pmm 9/8/2009 18:29'!
argumentCount
	self subclassResponsibility! !

!WARoute methodsFor: 'testing' stamp: 'lr 7/25/2011 10:56'!
consumes: aMimeType
	^ consumes matches: aMimeType! !

!WARoute methodsFor: 'accessing' stamp: 'lr 7/25/2011 10:56'!
consumesPriorityFor: aMimeType
	^ consumes priorityFor: aMimeType! !

!WARoute methodsFor: 'initialization' stamp: 'pmm 2/13/2011 10:38'!
initializeWithMethod: aString selector: aSymbol produces: aProducesMimeTypeMatch consumes: aConsumesMimeTypeMatch 
	self initialize.
	method := aString.
	selector := aSymbol.
	produces := aProducesMimeTypeMatch.
	consumes := aConsumesMimeTypeMatch! !

!WARoute methodsFor: 'public' stamp: 'pmm 9/9/2009 07:00'!
mapArgumentsWithElements: anStringArray parameters: aDictionary into: anArray
	self subclassResponsibility! !

!WARoute methodsFor: 'testing' stamp: 'pmm 3/22/2011 14:33'!
matchesFlexibleNumberOfPathElements
	self subclassResponsibility! !

!WARoute methodsFor: 'testing' stamp: 'pmm 9/8/2009 17:13'!
matchesParameters: aDictionary
	self subclassResponsibility! !

!WARoute methodsFor: 'testing' stamp: 'pmm 9/7/2009 00:28'!
matchesPath: aCollectionOfStrings
	self subclassResponsibility! !

!WARoute methodsFor: 'accessing' stamp: 'pmm 9/6/2009 22:05'!
method
	^ method! !

!WARoute methodsFor: 'accessing' stamp: 'pmm 9/6/2009 22:07'!
pathElementCount
	self subclassResponsibility! !

!WARoute methodsFor: 'printing' stamp: 'NickAger 8/13/2011 15:28'!
printOn: aStream
	super printOn: aStream.

	aStream 
		nextPutAll: ' (method: '; print: self method;
		nextPutAll: ' selector: '; print: self selector;
		nextPutAll: ' produces: '; print: self seasideMimeType;
		nextPutAll: ' consumes: '; print: consumes;
		nextPut: $)! !

!WARoute methodsFor: 'accessing' stamp: 'pmm 9/7/2009 00:25'!
priority
	self subclassResponsibility! !

!WARoute methodsFor: 'testing' stamp: 'lr 7/25/2011 10:56'!
produces: aCollectionOfAccept
	^ aCollectionOfAccept anySatisfy: [ :each | produces matches: each value ]! !

!WARoute methodsFor: 'accessing' stamp: 'pmm 7/28/2011 21:38'!
producesPriorityFor: aMimeType
	^ produces priorityFor: aMimeType! !

!WARoute methodsFor: 'accessing' stamp: 'pmm 7/28/2011 21:55'!
seasideMimeType
	"Answer the value of the content-type header according to the value of <consumes: >.
	Anwer nil for missing values."
	^ produces seasideMimeType! !

!WARoute methodsFor: 'accessing' stamp: 'pmm 9/6/2009 22:06'!
selector
	^ selector! !

!WARoute methodsFor: 'public' stamp: 'lr 7/25/2011 10:56'!
sendSelectorWith: anArrayOfArguments to: anObject
	^ anObject perform: selector withArguments: anArrayOfArguments! !

WARoute subclass: #WASimpleRoute
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

!WASimpleRoute commentStamp: 'DamienPollet 6/27/2011 16:35' prior: 0!
I match only on an exact number of path elements and no URL parameters. The path elements are turned into message arguments.

Instance Variables:
	count	<Integer>
		
count
	- The exact number of path elements that have to be present.!

!WASimpleRoute class methodsFor: 'instance creation' stamp: 'pmm 10/17/2010 15:51'!
method: aString selector: aSymbol
	^ self
		method: aString
		selector: aSymbol
		produces: WAWildcardMimeTypeMatch new
		consumes: WAWildcardMimeTypeMatch new! !

!WASimpleRoute class methodsFor: 'instance creation' stamp: 'pmm 8/27/2011 11:44'!
method: aString selector: aSymbol produces: aProducesMimeTypeMatch consumes: aConsumesMimeTypeMatch
	"Can't send #count: in VAST"
	| count |
	count := 0.
	aSymbol do: [ :each |
		each = $: 
			ifTrue: [ count := count + 1 ] ].
	^ self basicNew
		initializeWithMethod: aString
		count: count
		selector: aSymbol
		produces: aProducesMimeTypeMatch
		consumes: aConsumesMimeTypeMatch! !

!WASimpleRoute methodsFor: 'accessing' stamp: 'pmm 9/8/2009 18:29'!
argumentCount
	^ self pathElementCount! !

!WASimpleRoute methodsFor: 'initialization' stamp: 'pmm 2/13/2011 10:37'!
initializeWithMethod: aString count: anInteger selector: aSymbol produces: aProducesMimeTypeMatch consumes: aConsumesMimeTypeMatch 
	self initializeWithMethod: aString selector: aSymbol produces: aProducesMimeTypeMatch consumes: aConsumesMimeTypeMatch .
	count := anInteger! !

!WASimpleRoute methodsFor: 'public' stamp: 'pmm 9/9/2009 07:01'!
mapArgumentsWithElements: anStringArray parameters: aDictionary into: anArray
	1 to: self argumentCount do: [ :index |
		anArray at: index put: (anStringArray at: index) ]! !

!WASimpleRoute methodsFor: 'testing' stamp: 'pmm 3/22/2011 14:33'!
matchesFlexibleNumberOfPathElements
	^ false! !

!WASimpleRoute methodsFor: 'testing' stamp: 'pmm 9/8/2009 17:13'!
matchesParameters: aDictionary
	^ aDictionary isEmpty! !

!WASimpleRoute methodsFor: 'testing' stamp: 'pmm 9/8/2009 13:02'!
matchesPath: aCollectionOfStrings
	^ self pathElementCount = aCollectionOfStrings size! !

!WASimpleRoute methodsFor: 'accessing' stamp: 'pmm 9/6/2009 21:55'!
pathElementCount
	^ count! !

!WASimpleRoute methodsFor: 'accessing' stamp: 'pmm 9/7/2009 00:25'!
priority
	^ self pathElementCount! !

WAObject subclass: #WARouteBuilder
	instanceVariableNames: 'compiled method path produces consumes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

WARouteBuilder class
	instanceVariableNames: 'configuration'!

!WARouteBuilder commentStamp: 'pmm 7/28/2011 21:34' prior: 0!
I am a builder for building WARoute instances from a CompiledMethod.

Instance Variables:
	compiled	<CompiledMethod>
	method		<String>
	path		<String>
	produces	<WAWildcardMimeTypeMatch|WAMimeTypeMatch>
	consumes	<Collection<WAWildcardMimeTypeMatch|WAMimeTypeMatch>>

Class Instance Variables:
	configuration	<Collection>!

WARouteBuilder class
	instanceVariableNames: 'configuration'!

!WARouteBuilder class methodsFor: 'public' stamp: 'lr 7/26/2011 11:17'!
createRoutesFor: aClass
	^ self createRoutesFrom: aClass to: aClass! !

!WARouteBuilder class methodsFor: 'public' stamp: 'lr 7/26/2011 14:14'!
createRoutesFrom: aClass to: aSuperClass
	| current seen routes |
	current := aClass.
	seen := IdentitySet new.
	routes := OrderedCollection new.
	[ current notNil ] whileTrue: [ 
		current methodDictionary keysAndValuesDo: [ :selector :method |
			(seen includes: selector) ifFalse: [
				| pragmas |
				pragmas := method pragmas
					select: [ :pragma | configuration includes: pragma keyword ].
				pragmas isEmpty ifFalse: [
					routes add: (pragmas
						inject: (self on: method)
						into: [ :builder :pragma | builder perform: pragma keyword withArguments: pragma arguments ])
							create ].
				seen add: selector ] ].
		current = aSuperClass
			ifTrue: [ ^ routes ].
		current := current superclass ].
	^ routes! !

!WARouteBuilder class methodsFor: 'initialization' stamp: 'lr 7/26/2011 11:32'!
initialize
	configuration := IdentitySet new.
	(Pragma allNamed: #configuration in: self)
		do: [ :pragma | configuration add: pragma selector ]! !

!WARouteBuilder class methodsFor: 'instance creation' stamp: 'lr 7/26/2011 14:14'!
on: aCompiledMethod
	^ self basicNew initializeOn: aCompiledMethod! !

!WARouteBuilder methodsFor: 'configuration' stamp: 'lr 7/26/2011 11:32'!
consumes: aString
	<configuration>
	
	consumes add: (WAMimeTypeMatch fromString: aString)! !

!WARouteBuilder methodsFor: 'configuration methods' stamp: 'lr 7/26/2011 11:32'!
copy
	<configuration>
	
	self method: 'COPY'! !

!WARouteBuilder methodsFor: 'private' stamp: 'lr 7/26/2011 11:23'!
create
	^ path isNil
		ifTrue: [ self createSimpleRoute ]
		ifFalse: [ self createComplexRoute ]! !

!WARouteBuilder methodsFor: 'private' stamp: 'pmm 7/28/2011 21:35'!
createComplexRoute
	^ WAComplexRoute
		method: method selector: compiled selector pattern: path
		arguments: (GRPlatform current argumentNamesOf: compiled)
		produces: produces
		consumes: (self createMimeTypeMatch: consumes)! !

!WARouteBuilder methodsFor: 'private' stamp: 'lr 7/26/2011 11:23'!
createMimeTypeMatch: aCollection
	^ aCollection isEmpty
		ifTrue: [ WAWildcardMimeTypeMatch new ]
		ifFalse: [ WACompositeMimeTypeMatch matches: aCollection ]! !

!WARouteBuilder methodsFor: 'private' stamp: 'pmm 7/28/2011 21:34'!
createSimpleRoute
	^ WASimpleRoute
		method: method
		selector: compiled selector
		produces: produces
		consumes: (self createMimeTypeMatch: consumes)! !

!WARouteBuilder methodsFor: 'configuration methods' stamp: 'lr 7/26/2011 11:32'!
delete
	<configuration>
	
	self method: 'DELETE'! !

!WARouteBuilder methodsFor: 'configuration methods' stamp: 'lr 7/26/2011 11:32'!
get
	<configuration>
	
	self method: 'GET'! !

!WARouteBuilder methodsFor: 'initialization' stamp: 'pmm 7/28/2011 21:27'!
initializeOn: aCompiledMethod
	self initialize.
	compiled := aCompiledMethod.
	method := 'GET'.
	path := nil.
	consumes := OrderedCollection new.
	produces := WAWildcardMimeTypeMatch new! !

!WARouteBuilder methodsFor: 'configuration' stamp: 'lr 7/26/2011 11:32'!
method: aString
	<configuration>
	
	method := aString asUppercase! !

!WARouteBuilder methodsFor: 'configuration methods' stamp: 'lr 7/26/2011 11:32'!
move
	<configuration>
	
	self method: 'MOVE'! !

!WARouteBuilder methodsFor: 'configuration' stamp: 'lr 7/26/2011 11:32'!
path: aString
	<configuration>
	
	path := aString! !

!WARouteBuilder methodsFor: 'configuration methods' stamp: 'lr 7/26/2011 11:32'!
post
	<configuration>
	
	self method: 'POST'! !

!WARouteBuilder methodsFor: 'configuration' stamp: 'pmm 7/28/2011 21:34'!
produces: aString
	<configuration>
	
	produces := WAMimeTypeMatch fromString: aString! !

!WARouteBuilder methodsFor: 'configuration methods' stamp: 'lr 7/26/2011 11:32'!
put
	<configuration>
	
	self method: 'PUT'! !

WAObject subclass: #WARouteContainer
	instanceVariableNames: 'pathElementCount routes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

!WARouteContainer commentStamp: '<historical>' prior: 0!
A WARouteCountainer is a collection of routes that all accept the same number of path elements ordered by priority.

Instance Variables
	pathElementCount:		<Integer>
	routes:		<SortedCollection<WARoute>>

pathElementCount
	- the number of path elements that any of the routes in this container accepts

routes
	- the routes ordered by priority
!

!WARouteContainer class methodsFor: 'instance creation' stamp: 'pmm 9/8/2009 21:49'!
pathElementCount: anInteger
	^ self basicNew initializeWith: anInteger! !

!WARouteContainer class methodsFor: 'instance creation' stamp: 'pmm 8/27/2011 11:48'!
routes: aCollectionOfRoutes
	^ (self pathElementCount: aCollectionOfRoutes first pathElementCount)
		addRoutes: aCollectionOfRoutes;
		yourself! !

!WARouteContainer methodsFor: 'public' stamp: 'pmm 9/8/2009 17:24'!
addRoute: aRoute
	^ routes add: aRoute! !

!WARouteContainer methodsFor: 'public' stamp: 'pmm 9/8/2009 22:10'!
addRoutes: aCollectionOfRoutes
	aCollectionOfRoutes do: [ :each |
		self addRoute: each ]! !

!WARouteContainer methodsFor: 'private' stamp: 'pmm 8/21/2011 16:35'!
compare: a and: b byAccept: aSortedCollectionOfAccept
	^ self compare: a and: b using: aSortedCollectionOfAccept! !

!WARouteContainer methodsFor: 'private' stamp: 'pmm 8/22/2011 10:22'!
compare: a and: b byContentType: aMimeType thenByAccept: aSortedCollectionOfAccept
	| aPriority bPriority |
	aPriority := a consumesPriorityFor: aMimeType.
	bPriority := b consumesPriorityFor: aMimeType.
	^ aPriority ~= bPriority
		ifTrue: [ aPriority < bPriority ifTrue: [ -1 ] ifFalse: [ 1 ] ]
		ifFalse: [
			aSortedCollectionOfAccept isEmpty
				ifTrue: [ 0 "both are equal" ]
				ifFalse: [ self compare: a and: b byAccept: aSortedCollectionOfAccept ] ]! !

!WARouteContainer methodsFor: 'private' stamp: 'pmm 8/22/2011 10:18'!
compare: a and: b using: aSortedCollectionOfAccept
	aSortedCollectionOfAccept acceptsDo: [ :accepts |
		| aPriority bPriority |
		aPriority := -1.
		bPriority := -1.
		accepts do: [ :each |
			aPriority := aPriority max: (a producesPriorityFor: each).
			bPriority := bPriority max: (b producesPriorityFor: each) ].
		aPriority ~= bPriority
			ifTrue: [
				^ aPriority < bPriority ifTrue: [ -1 ] ifFalse: [ 1 ] ] ].
	^ 0 "both are equal"! !

!WARouteContainer methodsFor: 'private' stamp: 'pmm 8/21/2011 16:36'!
compareByPathThenContentType: aMimeType thenByAccept: aSortedCollectionOfAccept
	^ [ :a :b |
		| aPathPriority bPathPriority |
		aPathPriority := a priority.
		bPathPriority := b priority.
		(aPathPriority ~= bPathPriority or: [ aMimeType isNil and: [ aSortedCollectionOfAccept isNil ] ])
			ifTrue: [ aPathPriority < bPathPriority ifTrue: [ -1 ] ifFalse: [ 1 ] ]
			ifFalse: [
				aMimeType isNil
					ifTrue: [ self compare: a and: b byAccept: aSortedCollectionOfAccept ]
					ifFalse: [ self compare: a and: b byContentType: aMimeType thenByAccept: aSortedCollectionOfAccept ] ] ]
	! !

!WARouteContainer methodsFor: 'initialization' stamp: 'pmm 2/13/2011 10:37'!
initializeWith: anInteger
	self initialize.
	pathElementCount := anInteger.
	routes := SortedCollection sortBlock: [ :a :b |
		a priority > b priority ]! !

!WARouteContainer methodsFor: 'public' stamp: 'pmm 9/8/2009 17:26'!
pathElementCount
	^ pathElementCount! !

!WARouteContainer methodsFor: 'public' stamp: 'pmm 8/27/2011 11:48'!
routeForElements: aCollection parameters: aDictionary contentType: aMimeType accept: aCollectionOfAccept ifAbsent: anAbsentBlock
	| result sortedAccept |
	result := (routes select: [ :each |
			(each matchesPath: aCollection)
				and: [ (each matchesParameters: aDictionary)
				and: [ (aMimeType isNil or: [ each consumes: aMimeType ])
				and: [ aCollectionOfAccept isNil or: [ each produces: aCollectionOfAccept ] ] ] ] ]) asArray.
	result isEmpty
		ifTrue: [ ^ anAbsentBlock value ].
	result size = 1
		ifTrue: [ ^ result first ].
	sortedAccept := WASortedAccepts accepts: aCollectionOfAccept.
	result sort: (self sortByPathThenContentType: aMimeType thenByAccept: sortedAccept).
	
	"when the first and second highest priority match have the same priority we have an conflict"
	^ ((self compareByPathThenContentType: aMimeType thenByAccept: sortedAccept) value: result first value: result second) = 0
		ifTrue: [ anAbsentBlock value ]
		ifFalse: [ result first ]! !

!WARouteContainer methodsFor: 'public' stamp: 'pmm 3/22/2011 21:01'!
routes
	^ routes! !

!WARouteContainer methodsFor: 'private' stamp: 'pmm 8/21/2011 18:44'!
sortByPathThenContentType: aMimeType thenByAccept: aSortedCollectionOfAccept
	| block |
	block := self compareByPathThenContentType: aMimeType thenByAccept: aSortedCollectionOfAccept.
	^ [ :a :b |
		(block value: a value: b) = 1 ]
	! !

WAObject subclass: #WARouteResult
	instanceVariableNames: 'route elements parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

!WARouteResult commentStamp: 'pmm 7/28/2011 20:27' prior: 0!
I am the result of a route look up. I contain all the infomration required to "execute" the result.

Instance Variables:
	route	<WARoute>
	elements	<Collection<String>>
	parameters	<WARequestFields>
		
route
	the found route
	
elements
	the unconsumed path elements of the request
	
parameters
	the query fields of the request!

!WARouteResult class methodsFor: 'instance creation' stamp: 'lr 7/25/2011 11:05'!
route: aRoute elements: anArray parameters: aDictionary
	^ self basicNew initializeWithRoute: aRoute elements: anArray parameters: aDictionary! !

!WARouteResult methodsFor: 'accessing' stamp: 'pmm 9/2/2009 11:08'!
elements
	^ elements! !

!WARouteResult methodsFor: 'initialization' stamp: 'pmm 2/13/2011 10:32'!
initializeWithRoute: aRoute elements: anArray parameters: aDictionary
	self initialize.
	route := aRoute.
	elements := anArray.
	parameters := aDictionary! !

!WARouteResult methodsFor: 'accessing' stamp: 'pmm 9/2/2009 11:08'!
route
	^ route! !

!WARouteResult methodsFor: 'accessing' stamp: 'pmm 7/28/2011 21:56'!
seasideMimeType
	"Answer the value of the content-type header according to the value of <consumes: >.
	Anwer nil for missing values."
	^ route seasideMimeType! !

!WARouteResult methodsFor: 'public' stamp: 'pmm 9/9/2009 19:31'!
sendMessageTo: anObject
	| arguments |
	arguments := Array new: route argumentCount.
	route mapArgumentsWithElements: elements parameters: parameters into: arguments.
	^ route
		sendSelectorWith: arguments
		to: anObject! !

WAObject subclass: #WASortedAccepts
	instanceVariableNames: 'accepts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-REST-Core-Route'!

!WASortedAccepts class methodsFor: 'instance creation' stamp: 'pmm 8/22/2011 09:58'!
accepts: aCollectionOfAccepts
	^ self basicNew initializeWithAccepts: aCollectionOfAccepts! !

!WASortedAccepts methodsFor: 'initialization' stamp: 'pmm 1/22/2012 16:36'!
acceptsDo: aOneArgumentBlock
	| sortedKeys |
	sortedKeys := accepts keys sorted: [ :a :b | a > b ].
	sortedKeys do: [ :each |
		aOneArgumentBlock value: (accepts allAt: each) ]! !

!WASortedAccepts methodsFor: 'initialization' stamp: 'pmm 8/22/2011 10:21'!
initializeWithAccepts: aCollectionOfAccepts
	self initialize.
	accepts := GROrderedMultiMap new.
	aCollectionOfAccepts isNil ifFalse: [
		aCollectionOfAccepts do: [ :each |
			accepts at: each quality add: each value ] ]! !

!WASortedAccepts methodsFor: 'testing' stamp: 'pmm 8/22/2011 10:22'!
isEmpty
	^ accepts isEmpty! !
WARouteBuilder initialize!
